
import AbstractModel, { type IAbstract } from './abstractModel'
import type { IList } from './list'

export interface IUserSettings extends IAbstract {
	name: string
	emailRemindersEnabled: boolean
	discoverableByName: boolean
	discoverableByEmail: boolean
	overdueTasksRemindersEnabled: boolean
	defaultListId: undefined | IList['id']
	weekStart: 0 | 1 | 2 | 3 | 4 | 5 | 6
	timezone: string
}

export default class UserSettingsModel extends AbstractModel implements IUserSettings {
	name = ''
	emailRemindersEnabled = true
	discoverableByName = false
	discoverableByEmail = false
	overdueTasksRemindersEnabled = true
	defaultListId: undefined | IList['id'] = undefined
	weekStart: 0 | 1 | 2 | 3 | 4 | 5 | 6 = 0
	timezone = ''

	constructor(data: Partial<IUserSettings>) {
		super()
		this.assignData(data)
	}
}